#!/bin/env dls-python
import PandATest

"""
LVDS Loop Back (LB) test
"""


class LvdsLB(PandATest.PandATest):

    def __init__(self, *args, **kwargs):
        super(LvdsLB, self).__init__(*args, **kwargs)

    def get_user_input(self):
        inputy = '.'
        while inputy not in ['']:
            print "Loopback connecters for LVDS connected, OK ? [return]"
            inputy = raw_input()

    def test_code(self):
        outputs = [1, 2]
        inputs = [1, 2]
        ch_connect = {
            outputs[0]: inputs[0],
            outputs[1]: inputs[1]
        }
        default = 0
        for outp in outputs:
            for val in [1, 0]:
                out_cmd = 'LVDSOUT{}.VAL={}'.format(outp, self.toggle_cmd[val])
                self.set_output(out_cmd)
                in_cmd = 'LVDSIN{}.VAL?'
                self.toggle_check(in_cmd, outp, inputs, ch_connect[outp], default, val)

        return not all(self.test_result)