#!/bin/env dls-python
import PandATest

"""
TTL Loop Back (LB) test
"""

class TtlLB(PandATest.PandATest):

    def __init__(self, *args, **kwargs):
        super(TtlLB, self).__init__(*args, **kwargs)

    def get_user_input(self):
        inputy = '.'
        while inputy not in ['']:
            print "Loopback connecters for TTL connected, OK ? [return]"
            inputy = raw_input()

    def test_code(self):
        outputs = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
        inputs = [1, 2, 3, 4, 5, 6]
        ch_connect = {
            outputs[0]: inputs[0],
            outputs[1]: inputs[1],
            outputs[2]: inputs[2],
            outputs[3]: inputs[3],
            outputs[4]: inputs[4],
            outputs[5]: inputs[5],
            outputs[6]: inputs[0],
            outputs[7]: inputs[1],
            outputs[8]: inputs[2],
            outputs[9]: inputs[3]
        }

        default = 0
        for outp in outputs:
            for val in [1, 0]:
                out_cmd = 'TTLOUT{}.VAL={}'.format(outp, self.toggle_cmd[val])
                self.set_output(out_cmd)
                in_cmd = 'TTLIN{}.VAL?'
                self.toggle_check(in_cmd, outp, inputs, ch_connect[outp], default, val)

        return not all(self.test_result)