#!/bin/env dls-python
import PandATest

"""
LVDS Unplugged (U) test
"""


class LvdsU(PandATest.PandATest):

    def __init__(self, *args, **kwargs):
        super(LvdsU, self).__init__(*args, **kwargs)

    def get_user_input(self):
        inputy = '.'
        while inputy not in ['']:
            print "Loopback connecters for LVDS NOT connected, OK ? [return]"
            inputy = raw_input()

    def test_code(self):
        inputs = [1, 2]
        outputs = [1, 2]

        default = 1
        for outp in outputs:
            for val in [1, 0]:
                out_cmd = 'LVDSOUT{}.VAL={}'.format(outp, self.toggle_cmd[val])
                self.set_output(out_cmd)
                in_cmd = 'LVDSIN{}.VAL?'
                self.toggle_check(in_cmd, outp, inputs, -1, default, val)

        return not all(self.test_result)