#!/bin/env dls-python
import PandATest

"""
TTL Unplugged (U) test
"""


class TtlU(PandATest.PandATest):

    def __init__(self, *args, **kwargs):
        super(TtlU, self).__init__(*args, **kwargs)

    def get_user_input(self):
        inputy = '.'
        while inputy not in ['']:
            print "Loopback connecters for TTL NOT connected, OK ? [return]"
            inputy = raw_input()

    def test_code(self):
        outputs = [1,2,3,4,5,6,7,8,9,10]
        inputs = [1,2,3,4,5,6]

        default = 0
        for outp in outputs:
            for val in [1, 0]:
                out_cmd = 'TTLOUT{}.VAL={}'.format(outp, self.toggle_cmd[val])
                self.set_output(out_cmd)
                in_cmd = 'TTLIN{}.VAL?'
                self.toggle_check(in_cmd, outp, inputs, -1, default, val)

        return not all(self.test_result)